/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include "project.h"

volatile uint8 x = 0x00;

void InitDAM_1(void)
{
	/* Defines for DMA_1 */
	#define DMA_1_BYTES_PER_BURST 1
	#define DMA_1_REQUEST_PER_BURST 1
	#define DMA_1_SRC_BASE (CYDEV_SRAM_BASE)
//	#define DMA_1_DST_BASE (CYDEV_SRAM_BASE)
	#define DMA_1_DST_BASE (CYDEV_CLKDIST_BASE)

	/* Variable declarations for DMA_1 */
	/* Move these variable declarations to the top of the function */
	uint8 DMA_1_Chan;
	uint8 DMA_1_TD[1];

	/* DMA Configuration for DMA_1 */
	DMA_1_Chan = DMA_1_DmaInitialize(DMA_1_BYTES_PER_BURST, DMA_1_REQUEST_PER_BURST, HI16(DMA_1_SRC_BASE), HI16(DMA_1_DST_BASE));
	DMA_1_TD[0] = CyDmaTdAllocate();
	CyDmaTdSetConfiguration(DMA_1_TD[0], 1, DMA_1_TD[0], DMA_1__TD_TERMOUT_EN | CY_DMA_TD_AUTO_EXEC_NEXT);
	CyDmaTdSetAddress(DMA_1_TD[0], LO16((uint32)&x), LO16((uint32)CYDEV_IO_PRT_PRT3_AMUX));
	CyDmaChSetInitialTd(DMA_1_Chan, DMA_1_TD[0]);
	CyDmaChEnable(DMA_1_Chan, 1);
}

CY_ISR(isr_1_handler)
{
	x++;
	x &= 0x03;
	isr_1_ClearPending();
}

int main(void)
{
	SW_1_Start();
	SW_2_Start();
	SW_3_Start();
	SW_4_Start();
	
	SW_1_Close();
	SW_2_Close();
	SW_3_Close();
	SW_4_Close();
	isr_1_StartEx(isr_1_handler);
	InitDAM_1();
    CyGlobalIntEnable; /* Enable global interrupts. */

    for(;;)
    {
		CyDelay(1);
		Control_Reg_1_Write(1);
		Control_Reg_1_Write(0);
    }
}

/* [] END OF FILE */
